/*
hnewblk.c Version 0.1.0  Hash add new block for overflow
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

long hnewblk(hashfmt *hshhdr)
   {
   DWORD msgerr;
   LPVOID lpMsgBuf;
   long ofst;
   hshhdr->reason = 0;
   ofst = (long) SetFilePointer(hshhdr->hndl,
      (long) 0, NULL,
      FILE_END);
   if (ofst == UINT_MAX)
      {
      msgerr = GetLastError();
      hshhdr->reason = SYS_ERR + msgerr;
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
         FORMAT_MESSAGE_FROM_SYSTEM |
         FORMAT_MESSAGE_IGNORE_INSERTS,
         NULL,           /* source */
         msgerr,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
         (LPTSTR) &lpMsgBuf,
         0,              /* msglen */
         NULL);          /* insertion values */
      fprintf(stderr,"hnewblk: %s\n", lpMsgBuf);
      LocalFree(lpMsgBuf);
      return(ofst);
      } /* SetFilePointer err */
   hputblk(hshhdr,ofst,hshhdr->node);
   return(ofst);
   } /* hnewblk */
